\ Starts/Stops COG to control I/O pins
\ Mv4th16 version 0.93 required ( uses COG-EX word)
\ When COG is stopped all pins revert to inputs

QVARIABLE pins_cmdbuf

0 VALUE pins_cog

#40 VALUE pins_blk


: ina@ ( -- dPins )
  pins_cog IF
    pins_cmdbuf #1 COG-EX
  ELSE
    0.
  THEN ;

: outa@ ( -- dPins )
  pins_cog IF
    pins_cmdbuf #2 COG-EX
  ELSE
    0.
  THEN ;

: outa! ( dPins -- )
  pins_cog IF
    pins_cmdbuf #3 COG-EX
  ELSE
    DROP
  THEN ;

: dira@ ( -- dPins )
  pins_cog IF
    pins_cmdbuf #4 COG-EX
  ELSE
    0.
  THEN ;

: dira! ( dPins -- )
  pins_cog IF
    pins_cmdbuf #5 COG-EX
  ELSE
    DROP
  THEN ;

: ina-pin ( nPin -- fValue )
  pins_cog IF
    pins_cmdbuf #6 COG-EX
  ELSE
    DROP FALSE
  THEN ;

: outa-pin ( nPin -- fValue )
  pins_cog IF
    pins_cmdbuf #7 COG-EX
  ELSE
    DROP FALSE
  THEN ;

: dira-pin ( nPin -- fValue )
  pins_cog IF
    pins_cmdbuf #8 COG-EX
  ELSE
    DROP FALSE
  THEN ;
    
: outa-setpin ( nPin -- )
  pins_cog IF
    pins_cmdbuf #9 COG-EX
  ELSE
    DROP
  THEN ;

: dira-setpin ( nPin -- )
  pins_cog IF
    pins_cmdbuf #10 COG-EX
  ELSE
    DROP
  THEN ;

: outa-clrpin ( nPin -- )
  pins_cog IF
    pins_cmdbuf #11 COG-EX
  ELSE
    DROP
  THEN ;

: dira-clrpin ( nPin -- )
  pins_cog IF
    pins_cmdbuf #12 COG-EX
  ELSE
    DROP
  THEN ;
  
: outa-invpin ( nPin -- )
  pins_cog IF
    pins_cmdbuf #13 COG-EX
  ELSE
    DROP
  THEN ;

: dira-invpin ( nPin -- )
  pins_cog IF
    pins_cmdbuf #14 COG-EX
  ELSE
    DROP
  THEN ;

: waitpeq ( dPinsValue dPinsMask -- )
  pins_cog IF
    pins_cmdbuf #15 COG-EX
  ELSE
    2DROP
  THEN ;

: waitpne ( dPinsValue dPinsMask -- )
  pins_cog IF
    pins_cmdbuf #16 COG-EX
  ELSE
    2DROP
  THEN ;

: pins-stop ( -- )
  pins_cog ?DUP IF
    COG-STOP
    0 TO pins_cog
  THEN ;

: pins-run ( -- )
  pins_cog 0= IF
    0. pins_cmdbuf 2!
    pins_cmdbuf pins_blk COG-LOAD TO pins_cog
  THEN ;