\ This code must be formated in a special way to work with ForthTerm.
\ 1) there should be no printable comments in the code
\ 2) each forth word should start on a new text line.
\
\ If this code will replace the version included with ForthTerm
\ the following additional requirements must be met:
\ 1) load this code in ForthTerm code editor
\ 2) in program options dialog select the Block File tab
\    and seelect\check the following options:
\      "Start compiled words on a new line in block file"
\      "Word wrap block file"
\      "Synchronize to code editor"
\      "No block captions"
\ 3) Switch from "Code Editor" tab to "Block Manager" tab
\ 4) Select "Save As" option in "Block Manager" and select 
\    save as Text File and copy to:
\    "C:\Users\[USER_NAME]\AppData\Roaming\ForthTerm\Config\SaveBlock.txt"      

( Transfer contents of one or more blocks )
\ wait for a byte from console device
: sb-rxbyte ( uMsWait -- cByte fWasRead )
  BEGIN 
    KEY? IF 
      KEY SWAP EXIT 
    ELSE 
      1- 1 MS 
    THEN 
    DUP 0=
  UNTIL ;

\ Wait for a prompt to begin transfer
: sb-rxprompt ( -- f )
  \ wait for a > char followed by char #13
  #2000 sb-rxbyte IF
    [CHAR] > = IF
      #2000 sb-rxbyte IF
        #13 = 
        EXIT
      THEN
    THEN
  THEN 
  FALSE ;     
                                
: sb-txblock ( u -- )
  sb-rxprompt IF
    \ intialize check sum to zero
    0 SWAP
    ( uChkSum uBlockNum )
    BLOCK
    ( uChkSum aBlockBytes )
    \ there are 1024 bytes per block
    DUP #1024 +
    ( uChkSum aBlockBytes aBlockEnd )
    SWAP DO
      ( uChkSum )
      I C@ DUP EMIT 
      ( uChkSum cByte )
      +
      ( uChkSum' )
    LOOP
    \ invert send check sum, if = 0 send $FFFF
    ( uChkSum' )
    $FFFF XOR 
    ?DUP 0= IF 
      $FFFF 
    THEN    
    ( uChkSum'' )
    \ now send check sum low and high bytes
    DUP EMIT 
    #8 RSHIFT EMIT
    TRUE
  ELSE
    DROP
    FALSE
  THEN ;
  

: send-blocks ( FirstBlk LastBlk --  )
  \ send responce indicating we are ready to send
  [CHAR] < EMIT #13 EMIT
  \ read requested blocks 
  1+ SWAP ?DO 
    I sb-txblock 
    0= ABORT" Invalid request to send block" 
  LOOP ;
