\ This code must be formated in a special way to work with ForthTerm.
\ 1) there should be no printable comments in the code
\ 2) each forth word should start on a new text line.
\
\ If this code will replace the version included with ForthTerm
\ the following additional requirements must be met:
\ 1) load this code in ForthTerm code editor
\ 2) in program options dialog select the Block File tab
\    and seelect\check the following options:
\      "Start compiled words on a new line in block file"
\      "Word wrap block file"
\      "Synchronize to code editor"
\      "No block captions"
\ 3) Switch from "Code Editor" tab to "Block Manager" tab
\ 4) Select "Save As" option in "Block Manager" and select 
\    save as Text File and copy to:
\    "C:\Users\[USER_NAME]\AppData\Roaming\ForthTerm\Config\UploadBlock.txt"      

: getbyte ( uMsWait -- cByte fWasRead )
  BEGIN 
    KEY? IF 
      KEY SWAP EXIT 
    ELSE 
      1- 1 MS 
    THEN 
    DUP 0=
  UNTIL ;
  
: getbytes ( uMsWait adrBytes uByteCount -- FALSE | uChecksum ) 
  OVER + SWAP 
  2>R 0 2R> 
  ?DO 
    OVER getbyte IF
      DUP I C! + 
    ELSE 
      2DROP 
      UNLOOP 
      FALSE 
      EXIT 
    THEN 
  LOOP 
  NIP 
  $FFFF XOR 
  ?DUP 0= IF 
    $FFFF 
  THEN ;
    
: getchksum ( uMsWait -- FALSE | uChecksum )
  DUP getbyte IF 
    SWAP getbyte IF 
      #8 LSHIFT OR 
    ELSE 
      DROP FALSE 
    THEN 
  ELSE 
    DROP FALSE 
  THEN ;

: getblock ( uMsWait uBlockNum -- fWasDone )
  OVER >R BUFFER #1024 getbytes 
  DUP IF 
    R@ getchksum ?DUP IF 
      = DUP IF 
        UPDATE FLUSH 
      THEN 
    ELSE 
      DROP FALSE 
    THEN 
  THEN
  RDROP ;
  
  
: load-blocks ( uFirstBlock uLastBlock -- ) 
  1+ SWAP ?DO 
    \ send prompt
    [CHAR] > EMIT #13 EMIT
    \ read data bytes and save to specified block 
    #2000 I getblock NOT IF 
      UNLOOP 
      S" invalid block frame?" TYPE CR 
      ABORT 
    THEN 
  LOOP ;