( I2C Interface support )

\ 18 CONSTANT cmd_I2C_RESET
\ 19 CONSTANT cmd_I2C_READ
\ 20 CONSTANT cmd_I2C_WRITE
\ 21 CONSTANT cmd_I2C_START
\ 22 CONSTANT cmd_I2C_STOP
\ 23 CONSTANT cmd_I2C_SPEED

\ Reset the I2C interface.
: I2C-RESET ( c-Adr uByteCount -- )
  #18 SYSTEM ;              

\ Read the specified number of bytes from the I2C interface to global memory.
: I2C-READ ( c-Adr uByteCount -- )
  #19 SYSTEM ;              

\ Write specified number of bytes from global memory to the I2C interface.
: I2C-WRITE ( c-Adr uByteCount -- fAcked )
  #20 SYSTEM ;

\ Send a start bit on the I2C interface
: I2C-START ( -- )
  #21 SYSTEM ;

\ Send a stop bit on the I2C interface
: I2C-STOP ( -- )
  #22 SYSTEM ;

\ Set the I2c interface to run at @ 1Mbs
: I2C-SPEED ( dBitRate -- )
  #23 SYSTEM ;

\ Set the I2c interface to run at @ 1Mbs
: I2C-FAST ( -- )
  #1000000. I2C-SPEED ;

\ Set the I2c interface to run at @ 400 Kbs
: I2C-SLOW ( -- )
  #400000. I2C-SPEED ;

\ Read a single byte from the I2C interface
: I2C-C@ ( -- c )
  0 SP@ 1 I2C-READ ;

\ Write a single byte to the I2C interface
: I2C-C! ( c -- f  )
  SP@ 1 I2C-WRITE NIP ;
