( NEC IR code )

\ Block number that hold NEC IR binary
#16 VALUE ni_blk

\ there are eight params, each two bytes (word)

8 CELLS QBYTES ni_params

: ni_pin ni_params ;
: ni_headadr ni_params #2 + ;
: ni_tailadr ni_params #4 + ;
: ni_fifosize ni_params #6 + ;
: ni_bufadr ni_params #8 + ;
: ni_rptdelay ni_params #10 + ;
: ni_device ni_params #12 + ;
: ni_chkfun ni_params #14 + ;

0 VALUE ni_cog
VARIABLE ni_head
VARIABLE ni_tail
#64 QBYTES ni_buffer

: ni-clr ( -- )
  0 ni_head !
  0 ni_tail ! ;

\ initialize params
\ IR reciever is on pin 27
#27 ni_pin !
\ Set the fifo head and tail memory address
ni_head ni_headadr !
ni_tail ni_tailadr !
\ Set the fifo buffer memory address
ni_buffer ni_bufadr !
\ Set the fifo buffer memory size to 16 longs (32 bit)
#16 ni_fifosize !
\ Set the repeat code delay to 4 @ .5 seconds
#4 ni_rptdelay !
\ Set the device id to 0 to accept all device codes
0 ni_device !
\ 16 bit function code is realy 8 bits followed by inverted value
0 ni_chkfun !

: ni-code? ( -- f )
  ni_head @ ni_tail @ <> ;

: ni-code ( -- d )
  ni_tail @
  #4 * ni_buffer +
  Q@
  ni_tail @ 1+ 
  DUP #16 = IF
    DROP 0
  THEN
  ni_tail ! ;

: ni-run ( -- ) 
  ni-clr
  ni_params ni_blk COG-LOAD TO ni_cog ;

: ni-stop ( -- )
  ni_cog ?DUP IF
    COG-STOP
    0 TO ni_cog
  THEN ;
