\ sample tcp terminal, requires; NetConsole and Ps2Keyboard
MARKER unload-terminal

2VARIABLE destip

\ set 4 digit tcp address
#10 0 1 #14
 destip net-wrnet4

\ set tcp port number
#9999 VALUE destport

\ set our client side port number
#2048 VALUE localport

\ set our server side port number
#9999 VALUE svrport

\ set socket index to use
#3 VALUE sktidx

\ get next client side port number to use
\ ranges from 2049..4095
: doNxtPort ( -- uNextClientPort )
  localport 1+ #4095 AND
  DUP #2048 < IF 
    #2048 + 
  THEN ;

: doSetIp ( cByte3 cByte2 cByte1 cByte0 -- )
  destip net-wrnet4 ;

: doStat
  sktidx skt-status ;

: doConnect ( uDestPort adrDestIpAdr -- fConnected )
  2>R 
  sktidx 1 doNxtPort 2R> skt-open
  sktidx tcp-connect
  BEGIN
    \ see if we timed out or connected
    doStat DUP #23 = SWAP 0= OR
    \ if a key is pressed quit
    KEY? OR
    NOT
  WHILE
  \ not done so delay before we check again
    #10 MS
  REPEAT
  doStat #23 = ;

\ term emulation proccess a character
: ft-out ( cChar -- )
  DUP #32 < IF
    \ we have a control char
    CASE
      #13 OF #13 EMIT ENDOF
      #10 OF #10 EMIT ENDOF
      #11 OF CLR-EOL ENDOF
      #8  OF #8 EMIT ENDOF
      #2  OF nc-rx nc-rx SWAP AT-XY ENDOF
      #14 OF vt-insln ENDOF
      #15 OF vt-delln ENDOF
      #16 OF PAGE ENDOF
      #17 OF TRUE CURSOR ENDOF
      #18 OF FALSE CURSOR ENDOF
      #19 OF #19 nc-tx XY SWAP nc-tx nc-tx ENDOF
      #20 OF #20 nc-tx MAX-XY SWAP nc-tx nc-tx ENDOF
      #21 OF 1 vt-color ENDOF
      #22 OF 0 vt-color ENDOF     
    ENDCASE
  ELSE
    EMIT
  THEN ;

\ connect terminal via tcp
: doTerm ( -- )
  PAGE
  \ tell net console not to reconnect 
  FALSE TO net_autocon
  \ close current console connection
  nc-close
  ." connecting..." CR  
  destport destip doConnect IF
    ." connected." CR
    EMPTY-KEYS  
    sktidx TO nc_socket
    TRUE TO net_constat
    BEGIN
      net_constat
      ( fContinue )
      \ if F1 exit terminal
      EKEY? IF 
        kbd-peek $D0 = IF
          nc-close DROP FALSE
        THEN
      THEN     
    WHILE
      nc-rx? EMIT? AND IF 
        nc-rx ft-out 
      THEN
      
      nc-tx? IF
        EKEY? IF
          EKEY EKEY>CHAR IF
            nc-tx
          ELSE
            $D0 = IF
              nc-close DROP FALSE
            THEN  
          THEN
        THEN
      THEN
      
    REPEAT
    CR ." connection closed " CR
  ELSE   
    ." connection failed" CR
  THEN ;  
      
\ wait for a tcp connection and display on terminal      
: doListen ( -- )
  PAGE
  \ close current console connection
  nc-close
  \ tell net console to listen for new connection 
  TRUE TO net_autocon
  sktidx svrport nc-open IF
    ." Waiting for connection..." CR
    BEGIN
      EKEY? IF 
        kbd-peek $D0 = IF
          \ F1 pressed, close TCP connection and exit terminal
          nc-close
          EXIT
        THEN  
      THEN  
      nc-tcpbg net_constat
    UNTIL
    ." connected." CR
    EMPTY-KEYS  
    BEGIN
      nc-tcpbg
      nc-rx? net_constat OR
      ( fContinue )
      EKEY? IF 
        \ if F1 exit terminal
        kbd-peek $D0 = IF
          nc-close DROP FALSE
        THEN
      THEN     
    WHILE
      nc-rx? EMIT? AND IF 
        nc-rx ft-out 
      THEN
      KEY? nc-tx? AND IF
        KEY nc-tx
      THEN
    REPEAT
    CR ." connection closed " CR
  ELSE   
    ." listen failed " CR
  THEN ;  
      
\ destport destip doConnect .
     