( Output to NTSC/PAL TV using defered words; EMIT, and EMIT? )

: vt_cols tv_cols ;
: vt_rows tv_rows ; 

\ Terminal state values
0 VALUE vt_col 
0 VALUE vt_row 
0 VALUE vt_colidx

\ control hardware text cursor

TRUE VALUE vt_curon

\ Draw the cursor at the current X Y position
: vt-crcur ( -- )
  vt_curon IF
    vt_col tv_params C!
    vt_row tv_params 1+ C!
  THEN ;

\ set invert mode on/off
: vt-invert ( fInvertScreen -- )
  tv_params CELL + C! ;

\ Set cursor visible to on or off    
: vt-cursor ( fShow -- )
  DUP TO vt_curon
  IF
    vt-crcur
  ELSE
    \ Remove the cursor from the screen
    $FFFF tv_params ! ;
  THEN ;

\ Terminal erase functions

: vt-cln ( uRow - ) 
  0 SWAP tv-cln ;
  
: vt-cls ( -- )
  \ blank the screen buffer
  0 tv-cls 
  \  home the cursor
  0 TO vt_row 0 TO vt_col
  \ vpdate the cursor hardware register
  vt-crcur ;

: vt-clr-eol 
  vt_cols vt_col ?DO
    I vt_row 0 BL tv-out
  LOOP ;
  
: vt-clr-eos
  vt-clr-eol 
  vt_rows vt_row 1+ ?DO
    I vt-cln 
  LOOP ;

: vt-scrup 
  tv_screen DUP vt_cols + SWAP
  tv_screensize vt_cols - MOVE
  vt_rows 1- vt-cln ;
  
\ Terminal Character Output Functions

: vt-color ( uColorIdx -- )
  #7 AND TO vt_colidx ;
  
: vt-color@ ( -- uColorIdx )
  vt_colidx ;
  
: vt-cntrl ( c -- ) 
  CASE
    #13 OF 
      0 TO vt_col 
      vt-crcur 
    ENDOF
    #10 OF
      vt_row 1+ vt_rows MOD DUP TO vt_row
      0= IF
        vt-scrup vt_rows 1- TO vt_row
      THEN
      vt-crcur
    ENDOF
    #8 OF
      vt_col 0> IF
        vt_col 1- TO vt_col
        vt_col vt_row vt_colidx BL tv-out
        vt-crcur
      THEN 
    ENDOF
  ENDCASE ;

: vt-cr ( -- )
  #13 vt-cntrl #10 vt-cntrl ;
  
\ insert a row at the current row  
: vt-insln ( -- )
  \ if not last row push lines down 1 row
  vt_rows vt_row 1+ -
  ( uRowsToMove )
  ?DUP IF
    ( uRowsToMove )
    vt_cols *
    ( uBytesToMove )
    \ calc start address
    tv_screen vt_row vt_cols * +
    ( uBytesToMove uSourceAdr )
    DUP vt_cols +
    ( uBytesToMove uSourceAdr uDestAdr )
    ROT MOVE
  THEN
  vt_row vt-cln ;    

\ delete the current row  
: vt-delln ( -- )
  \ if not last row pull lines up 1 row
  vt_rows vt_row 1+ -
  ( uRowsToMove )
  ?DUP IF
    ( uRowsToMove )
    vt_cols *
    ( uBytesToMove )
    \ calc source address
    tv_screen vt_row 1+ vt_cols * +
    ( uBytesToMove uSourceAdr )
    \ calc destination address
    DUP vt_cols -
    ( uBytesToMove uSourceAdr uDestAdr )
    ROT MOVE
  THEN
  vt_rows 1- vt-cln ;    

: vt-emit? ( -- f )
  TRUE ;

: vt-emit ( cChar - )
  DUP #32 < IF 
    vt-cntrl 
  ELSE
    >R vt_col vt_row vt_colidx R> tv-out 
    vt_col 1+ vt_cols MOD DUP TO vt_col 
    0= IF
      vt-cr
    ELSE
      vt-crcur
    THEN
  THEN ;

\ Terminal cursor position functions

\ Sets the terminal display current column and row
: vt-xy ( uX uY - ) vt_rows MOD TO vt_row
  vt_cols MOD TO vt_col
  vt-crcur ;

\ Returns the terminal display current column and row
: vt-xy@ ( -- uX uY )
  vt_col vt_row ;

\ Returns the number of columns and rows on the display
: vt-max-xy ( -- uX uY ) 
  vt_cols vt_rows ;

\ Hook the forth character output and terminal words to the video terminal 
: vt>term ( -- )
  ( Set defered console words EMIT and EMIT? to use NTSC tv driver )
  ['] vt-emit IS EMIT 
  ['] vt-emit? IS EMIT?
  ( Set defered terminal words to use NTSC terminal )
  ['] vt-cls IS PAGE 
  ['] vt-cursor IS CURSOR
  ['] vt-xy IS AT-XY
  ['] vt-xy@ IS XY 
  ['] vt-max-xy IS MAX-XY 
  ['] vt-clr-eol IS CLR-EOL ;

\ set the color to index 0 and clear the terminal
0 vt-color vt-cls

\ : test HEX BEGIN KEY? UNTIL BEGIN 1000 MS KEY? WHILE KEY . REPEAT DECIMAL ;