( propellar TV text driver using modified 1 pin or 2 pin video driver )
\ provides a 40..80x25 monochrome video driver with invert
\ and hardware cursor.

\ These constants are for NTSC TV runtime

\ Block index that contains TV binary.
#25  VALUE  tv_blk 

\ Size of screen, must match hardware setting in COG driver
#80  CONSTANT  tv_cols_max
#28  CONSTANT  tv_rows_max
tv_cols_max tv_rows_max * CONSTANT tv_screensize

\ Size of screen, must match hardware setting in COG driver
tv_cols_max  VALUE  tv_cols
tv_rows_max  VALUE  tv_rows

\ Screen buffer
\ Allocate one 8 bit byte for each screen character
tv_screensize QBYTES tv_screen

\ A forth VALUE to hold COG used to run binary
0 VALUE tv_cog

\ TV driver will uses 2 pin(s)
0  VALUE tv_pin

#8 QBYTES tv_params
tv_params #8 ERASE 

( Stop TV driver cog if it is running )
: tv-stop ( -- )
  tv_cog ?DUP IF
    COG-STOP
    0 TO tv_cog
  THEN ;

( Start TV driver cog )
: tv-run ( -- )
  tv-stop
  tv_screen S>D #8 DLSHIFT tv_pin S>D DOR
  tv_params Q!
  tv_params tv_blk COG-LOAD TO tv_cog
  \ wait for tv cog to initialize
  tv_params #4 +
  ( adrRetParams )
  BEGIN
    DUP @
  UNTIL
  ( adrRetParams )
  DUP C@ SWAP 1+ C@
  ( uDrvCols uDrvRows )
  tv_rows_max MIN TO tv_rows
  tv_cols_max MIN TO tv_cols ;


( TV driver cog support routines )

: tv-adr ( uX uY -- uAdr )
  tv_cols * + tv_screen + ;

: tv-enc ( uColIdx cChar - uWord ) 
  SWAP 1 AND IF
    #128 OR
  THEN ;

: tv-cln ( uColIdx uRow - )
  0 SWAP tv-adr
  ( uColIdx uRowAdr )
  SWAP $20 tv-enc
  ( uRowAdr cEncChar )
  tv_cols SWAP FILL ;

: tv-cls ( UColIdx - ) 
  tv_rows 0 DO 
    DUP I tv-cln    
  LOOP 
  DROP ;

: tv-out ( uX uY uColIdx cChar - ) 
  tv-enc >R tv-adr R> SWAP C! ;
  