MARKER time-comp

\ Convert the value in cByte (0..99) to a packed BCD byte
: byte>bcd ( cByte -- cBcd )
  #10 /REM SWAP $F AND
  SWAP #4 LSHIFT OR ;

\ Get the next 4 bits (nibble) from a double value
: nextnib ( dValue -- dValue' uNibble ) 
  2DUP $F. DAND
  ( dValue dNibble )
  \ shift value right by 4 to remove nibble
  2SWAP #4 DRSHIFT 2SWAP
  \ convert 32 bit double to 16 bit single cell value
  DROP ;

\ Get next value from backed BCD 32 bit time value
: nextnum ( dValue -- dValue cNumber )
  nextnib >R 
  nextnib #10 * R> + ;

\ Split the double time value into four values
: splittime ( dTime -- uHun uSec uMin uHour )
  #4 0 DO 
    nextnum ROT ROT
  LOOP 2DROP ;

\ Convert the backed BCD 32 bit time value into a 32 bit 
\ value containg the number of 1/100ths of a second
: time>hund ( dTime -- dHundreths )
  splittime 0.
 ( uHun uSec uMin uHour dHund )
  \ add in hours
  ROT #3600 M* D+
  \ add in minutes
  ROT #60 M* D+
  \ add in seconds
  ROT S>D D+
  \ convert seconds to hundreths
  #100 UD* 
  \ add in hundreths
  ROT S>D D+ ;

: hund>hms ( dHundreths - uHour uMin uSec )
  #6000 SM/REM 
  #60 /REM ROT 
  #100 /REM 2SWAP ;

: time>hms ( dBcdTime -  uHour uMin uSec ) 
  time>hund 
  hund>hms ;

: hms>time ( uHour uMin uSec -- dBcdTime )
  0. #4 0 DO 
    ROT byte>bcd S>D #24 I #8 * - DLSHIFT
  DOR LOOP ;
