MARKER forget-tools

\ get max screen width
: scrwidth# ( -- uColumns )
  MAX-XY DROP ?DUP NOT IF
    #80  \ assume 80 columns
  THEN ;   
    
( SEE factor words )

: CFA>NFA ( cfa - 0 or NFA )
  DUP HERE < IF 
    LATEST @
    BEGIN 
      DUP 
    WHILE 
      2DUP >= IF
        NIP EXIT 
      ELSE 
        NFA>LFA @ 
      THEN 
    REPEAT
    2DROP 0 
  ELSE 
    DROP 0 
  THEN ;
  
: NATIVE? ( nfa - f ) 
  NFA>FFA @ 2 AND 0<> ;
  
: NATIVE>NFA ( xt - 0 or nfa )
  LATEST @ 
  BEGIN 
    DUP
  WHILE 
    DUP NATIVE? IF
      2DUP NFA>CFA @ = IF 
        NIP EXIT 
      THEN
    THEN 
    NFA>LFA @ 
  REPEAT 
  2DROP 0 ;

: byte. ( c -- ) DUP $10 U< IF $30 EMIT THEN U. ;

: word. ( u -- ) DUP $1000 U< IF $30 EMIT THEN
  DUP $100 U< IF $30 EMIT THEN DUP $10 U< IF $30 EMIT THEN U. ;

: xt.? ( xt - )
  DUP CFA>NFA ?DUP IF
    COUNT TYPE DROP TRUE
  ELSE
    NATIVE>NFA ?DUP IF 
      COUNT TYPE TRUE 
    ELSE 
      FALSE 
    THEN
  THEN ;
  
: xt. ( xt - )
  DUP xt.? IF
    DROP
  ELSE
    word.
  THEN ;

: xt-lit. ( u -- )
 DUP word. 
 xt.? DROP ;


( show word at a-adr1 as string, a-adr2 is next word address )

: xt-dis. ( a-adr1 -- a-adr2 ) DUP >R @ 
  CASE
    $07 OF 
      ." (nop)"
    ENDOF
    $08 OF
      ." (exit-adr)" 
    ENDOF  
    $0C OF 
        ." (exit)" 
    ENDOF
    $0E OF 
      ." (dliteral) " 
      R@ CELL+ 2@ UD. R> 2 CELLS + >R
    ENDOF
    $12 OF
      ." (adr-literal) " 
      R@ CELL+ @ xt-lit. R> CELL+ >R
    ENDOF
    $13 OF 
      ." (literal) " 
      R@ CELL+ @ xt-lit. 
      R> CELL+ >R 
    ENDOF
    $16 OF
      ." (0branch) " 
      R@ CELL+ @ xt-lit.
      R> CELL+ >R
    ENDOF
    $1C OF
      ." (branch) "
      R@ CELL+ @ xt-lit.
      R> CELL+ >R
    ENDOF
    $1E OF
      ." (loop) "
      R@ CELL+ @ word. R> CELL+ >R
    ENDOF
    $28 OF
      ." (+loop) "
      R@ CELL+ @ word. R> CELL+ >R
    ENDOF
    $38 OF 
      ." (s" $22 EMIT ." ) "
      R@ CELL+ COUNT 
      DUP 1+ ALIGNED R> + >R TYPE
    ENDOF
    $40 OF 
      ." (does) "
      R@ CELL+ @ xt-lit. R> CELL+ >R 
    ENDOF
    $48 OF 
      ." (execute)"
    ENDOF
  ( OTHERWISE )
    DUP xt. 
  ENDCASE
  R> CELL+ ;

( DUMP/.S factor words )

: xtline. ( xt-adr1 -- xt-adr2 ) DUP word. SPACE xt-dis. CR ;

: hexline. ( c-adr u -- ) OVER + SWAP ?DO I C@ byte. LOOP ;

: asciiline. ( c-adr u -- ) OVER + SWAP ?DO I C@ DUP
  #32 #128 WITHIN IF EMIT ELSE DROP $2E EMIT THEN LOOP ;

#16 VALUE dmp_bytes 
FALSE VALUE dmp_ascii
TRUE VALUE dmp_cr

: dump16 ( c-adr uScrWidth -- )
  SWAP DUP
  ( uScrWidth c-adr c-adr )
  dmp_bytes hexline.
  ( uScrWidth c-adr ) 
  NIP dmp_ascii IF
    ( c-adr )
    SPACE dmp_bytes asciiline.
  ELSE
    DROP  
  THEN
  dmp_cr IF CR THEN ;   

: typeword ( a-adr -- ) COUNT TYPE SPACE ;

: wordsize ( a-adr -- u ) COUNT NIP 1+ ;

: fitword. ( a-adr1 u1 u2 -- f ) ROT DUP >R wordsize + >=
  IF R@ typeword TRUE ELSE FALSE THEN R> DROP ;

: wordend ( nfa -- nfa2 ) 
  HERE 4 + >R 
  LATEST @
  BEGIN
    DUP
  WHILE
    2DUP < IF
      RDROP DUP >R
    THEN
    NFA>LFA @
  REPEAT
  2DROP R> NFA>LFA ;

( List the definition names in the word list )

: WORDS ( -- ) 
  scrwidth# >R
  CR 0 LATEST @ 
  BEGIN 
    DUP 
  WHILE 
    2DUP SWAP R@ 1-
    SWAP fitword. 
    NOT IF 
      CR NIP 0 SWAP 2DUP SWAP R@ 1- SWAP fitword.
      DROP 
    THEN 
    DUP wordsize ROT + 
    SWAP NFA>LFA @ 
  REPEAT 
  RDROP
  2DROP CR ;

( Display representation of the named word definition. )

: SEE ( -- )
  BL WORD COUNT IF
    ( cadrWordName )
    1- FIND IF
      CR BASE @ >R HEX
      ( adrExecWord )
      DUP wordend >R
      BEGIN 
        DUP R@ <
      WHILE 
        xtline. 
      REPEAT  
      RDROP 
      DROP
      R> BASE !
    ELSE
      COUNT TYPE ." ?" CR
    THEN
  ELSE
    DROP  
  THEN ;


: (dmp-rows) ( uScreenWidth -- uByteCount fShowAscii )
  ( uScreenWidth uScreenWidth )
  CASE
   #8 #10 OF-RANGE
     1 
   ENDOF
   #10 #17 OF-RANGE
     #2
   ENDOF
   #17 #29 OF-RANGE
     #4
   ENDOF
   #29 #53 OF-RANGE
     #8
   ENDOF
   ( OTHERWISE )         
   #16 SWAP
 ENDCASE
 \ now see if we have roorm for ascii display
 DUP
 ( uByteCount uByteCount )
 #4 * #7 +  
 ( uByteCount uWithAscii )
 scrwidth# <= 
 ( uByteCount fShowAscii ) 
 ;
 
: dmp-cr? ( uByteCount fShowAscii -- fNeedCr )
  IF 
    ( uByteCount )
    #4 * #7 
  ELSE 
    ( uByteCount ) 
    #3 * #5 
  THEN
  + scrwidth# <> ;

       
( Display u consecutive addresses values starting at c-adr )
  
: DUMP ( c-adr uCnt -- )
  \ read max screen columns
  2>R scrwidth# 
  \ calc byes per line
  DUP (dmp-rows) 
  2DUP dmp-cr? TO dmp_cr 
  TO dmp_ascii TO dmp_bytes
  2R> 
  ( uScrWidth c-adr uCnt )
  \ save current numeric base and set to hex mode
  BASE @ >R HEX CR
  \ calc last address 
  OVER + SWAP
  ( uScrWidth c-adr' c-adr )
  ?DO 
    ( uScrWidth )
    I DUP word. SPACE
    ( uScrWidth uNextByteAdr )
    OVER
    ( uScrWidth uNextByteAdr uScrWidth )
    dump16
    dmp_bytes 
  +LOOP
  ( uScrWidth )
  DROP
  \ restore numeric base  
  R> BASE ! ;


( display the values currently on the data stack )

\ : .S ( -- ) 
\  CR SP@ S0 = IF 
\    ." Stack empty" 
\  ELSE 
\    SP@ S0 U> IF
\      ." Stack underflow "
\      SP@ S0 - U. 
\    ELSE 
\      SP@ 2- S0 2- ?DO
\        I @ U. 
\        -2 
\      +LOOP 
\    THEN
\  THEN ;

  