\ Configure Network Settings
\ Settings are save in block xx

\ This unit of code requires a terminal driver
\ and the "net-str" code

MARKER  UNLOAD-CFG

#14 VALUE cfg_blk


VARIABLE cfg_buf #30 ALLOT

\ set all network settings to zero
0. net_ip 2!
0. net_mask 2!
0. net_gw 2!
net_mac #6 ERASE

: cfg-ipstr S" IP: " ;
: cfg-maskstr S" MASK: " ;
: cfg-gwstr S" GW: " ;
: cfg-macstr S" MAC: " ;
: cfg-portstr S" PORT: " ;
: cfg-title S" \ Network Settings" ;

: cfg-ask ( -- c )
  ." (I)p Address  (G)ateway (S)ubnet mask"
  CR 
  ." (M)ac Address (P)ort    (Q)uit "
  CR CR
  ." Enter selection (I G S M P Q): "
  0
  EMPTY-KEYS
  BEGIN
    DROP
    KEY $DF AND
    ( cKey )
    DUP [CHAR] I = SWAP
    ( f1 cKey )
    DUP [CHAR] S = SWAP
    ( f1 f2 cKey )
    DUP [CHAR] G = SWAP
    ( f1 f2 f3 cKey )
    DUP [CHAR] M = SWAP
    ( f1 f2 f3 f4 cKey )
    DUP [CHAR] P = SWAP
    ( f1 f2 f3 f4 f5 cKey )
    DUP [CHAR] Q = SWAP
    ( f1 f2 f3 f4 f5 f6 cKey )
    >R OR OR OR OR OR R> SWAP
  UNTIL 
  #31 BACKSPACES ;
  
: cfg-error ( fValid -- )
  NOT IF
    CR
    ." Inavlid value " 
    [CHAR] " EMIT cfg_buf COUNT TYPE [CHAR] " EMIT 
    ."  Press any key to continue"
    EMPTY-KEYS KEY DROP CR
  THEN ;
  
: cfg-rdln ( -- )
  cfg_buf 1+ #17 ACCEPT cfg_buf C! ;

: cfg-edit ( -- fQuit )
  FALSE
  cfg-ask
  DUP [CHAR] M = IF
    DROP ." Enter MAC Address: " cfg-rdln net_mac cfg_buf net-str>mac cfg-error
  ELSE
    DUP [CHAR] I = IF
      DROP ." Enter IP Address: " cfg-rdln net_ip cfg_buf net-str>ip4 cfg-error
    ELSE
      DUP [CHAR] S = IF
        DROP ." Enter Subnet Mask: " cfg-rdln net_mask cfg_buf net-str>ip4 cfg-error
      ELSE
        DUP [CHAR] G = IF
          DROP ." Enter Gateway Address: " cfg-rdln net_gw cfg_buf net-str>ip4 cfg-error
        ELSE
          [CHAR] P = IF
            ." Enter Server Port: " cfg-rdln
            cfg_buf net-str>port IF
              TO net_defport
            THEN
          ELSE
            \ only commend left is quit
            DROP TRUE
          THEN
        THEN
      THEN
    THEN
  THEN ;
    

: cfg-div
  #24 [CHAR] - (chars) ;

: cfg-top
  cfg-title TYPE CR cfg-div ;

: cfg-lnadr ( uLine -- c-adr )
  ABS #63 MIN #6 LSHIFT cfg_blk BLOCK + ;

: -TRAILING ( c-adr uLen - c-adr uLen' )
  2DUP
  ( c-adr uLen c-adr uLen )
  OVER + 1-
  ( c-adr uLen cadrEnd+1 c-adrStrat )
  ?DO
    ( c-adr uLen )
    I C@ BL = IF
      1-
    ELSE
      LEAVE
    THEN
    -1
  +LOOP ;


: cfg-getstr ( c-adr uLen -- c-adr' uLen' )
  2>R 0
  BEGIN
    ( uCnt )
    DUP
    #16 <
  WHILE
    DUP cfg-lnadr
    ( uCnt c-adr2 )
    DUP 2R@ S= IF
      \ no match check next string
      ( uCnt' c-adr2 )
      DROP 1+
    ELSE
      \ we have a match
      ( uCnt' c-adr2 )
      NIP #64 -TRAILING
      2RDROP EXIT
    THEN
  REPEAT 
  ( uCnt' )
  DROP
  2R> DROP 0 ;

: cfg-value ( c-adr uLen -- c-adr' uLen' )
  2DUP cfg-getstr
  ( c-adr uLen c-adr2 uLen2 )
  DUP IF
    \ found the string, remove prefix
    ROT 
    ( c-adr c-adr2 uLen2 uLen )
    2DUP > IF
      /STRING
      ( c-adr c-adr2 uLen3 )
      ROT DROP
      ( c-adr2 uLen3 )
      \ remove any leading spaces
      BL SKIP
      ( c-adr3 uLen4 )
    ELSE
      ( c-adr c-adr2 uLen2 uLen )
      2DROP SWAP DROP 0
    THEN
  ELSE
    2SWAP 2DROP
  THEN ;

: cfg-getpar ( c-adr uCount -- )
  cfg-value cfg_buf >COUNTED ;
  
: cfg-getall ( -- )
  \ First read the ip address
  cfg-ipstr cfg-getpar
  net_ip cfg_buf net-str>ip4 DROP
  \ Next read the subnet mask
  cfg-maskstr cfg-getpar
  net_mask cfg_buf net-str>ip4 DROP
  \ Now for the gateway address
  cfg-gwstr cfg-getpar
  net_gw cfg_buf net-str>ip4 DROP
  \ Now for the Sever Port
  cfg-portstr cfg-getpar
  cfg_buf net-str>port IF
    TO net_defport 
  THEN
  \ Finally the MAC address
  cfg-macstr cfg-getpar
  net_mac cfg_buf net-str>mac DROP ;

: cfg-ip4. ( a-adr -- )
  cfg_buf net-ip4>str cfg_buf COUNT TYPE CR CR ;

: cfg-show ( -- )
  CR cfg-div CR cfg-top CR
  SPACE cfg-ipstr TYPE net_ip cfg-ip4.
  SPACE cfg-maskstr TYPE net_mask cfg-ip4.
  SPACE cfg-gwstr TYPE net_gw cfg-ip4.
  SPACE cfg-macstr TYPE net_mac
  cfg_buf net-mac>str cfg_buf COUNT TYPE CR CR
  SPACE cfg-portstr TYPE net_defport . CR
  cfg-div CR ;

: cfg-wr ( c-adr uLen a-adr -- )
  SWAP CMOVE ;

: cfg-wrstr ( c-adr uLen a-adr -- a-adr' )
  2DUP 2>R
  cfg-wr
  2R> + ;
  
: cfg-wrstrln ( c-adr uLen uLine -- a-adr' )
  cfg-lnadr cfg-wrstr ;

: cfg-save ( -- )
  \ fill screen with spaces
  cfg_blk BLOCK #1024 BLANK
  \ Write a comment
  cfg-title 0 cfg-wrstrln DROP
  \ Save the IP Address
  cfg-ipstr #2 cfg-wrstrln
  ( adrLine )
  net_ip cfg_buf net-ip4>str
  ( adrLine )
  cfg_buf COUNT ROT cfg-wr
  \ Save the Subnet Mask
  cfg-maskstr #4 cfg-wrstrln
  ( adrLine )
  net_mask cfg_buf net-ip4>str
  ( adrLine )
  cfg_buf COUNT ROT cfg-wr
  \ Save the Gateway Address
  cfg-gwstr #6 cfg-wrstrln
  ( adrLine )
  net_gw cfg_buf net-ip4>str
  ( adrLine )
  cfg_buf COUNT ROT cfg-wr
  \ Save the Default server Port
  cfg-portstr #8 cfg-wrstrln
  ( adrLine )
  net_defport net-port>str
  ROT cfg-wrstr DROP
  \ Save the Mac Address
  cfg-macstr #10 cfg-wrstrln
  ( adrLine )
  net_mac cfg_buf net-mac>str
  ( adrLine )
  cfg_buf COUNT ROT cfg-wr
  \ save block data
  UPDATE FLUSH ;

: cfg-edit ( -- )
  BEGIN
    PAGE
    cfg-show
    CR
    cfg-edit
  UNTIL
  cfg-save
  PAGE 
  cfg-show ;

: cfg-update? ( -- fUpdate )
  CR
  ." Update network settings (Y or N)? "
  EMPTY-KEYS
  100
  BEGIN
    KEY? IF
      \ we have a key see if we want it
      KEY $DF AND DUP [CHAR] Y = IF
        2DROP TRUE EXIT
      ELSE
        [CHAR] N = IF
          DROP FALSE EXIT
        THEN
      THEN
    ELSE
      30 MS
      1-
    THEN
    DUP 0=
  UNTIL ;

: cfg-run ( -- )
  SAVE-INPUT
  cfg-getall
  cfg-show
  cfg-update? IF
    CR cfg-edit
  ELSE
    CR
  THEN
  RESTORE-INPUT ;
