MARKER unload-terminal

FALSE VALUE TermEcho?

#27 CONSTANT ExitChar

\ Tcp port number of server to connect to
#9999 VALUE destport

\ Client side Tcp port number when connecting to a host
#2048 VALUE localport

\ Tcp port number to listen on in server mode
#9999 VALUE svrport

\ set socket index to use ( 0..3 )
#3 VALUE sktidx

\ get next client side port number to use
\ ranges from 2049..4095
: doNxtPort ( -- uNextClientPort )
  localport 1+ #4095 AND
  DUP #2048 < IF 
    #2048 + 
  THEN ;

\ variable to hold user input for ip address and port  
VARIABLE inp_buff #32 ALLOT
\ clear the buffer                                     
2VARIABLE ip_adr 0. ip_adr 2!                                   
                  
\ try to read an ip address from console                                                                
: getDestIp ( -- fValidOrBlank )                                                     
  ." Enter Host Ip Address: "                                        
  inp_buff 1+ #17 ACCEPT DUP inp_buff C!                        
  IF ip_adr inp_buff net-str>ip4 ELSE FALSE THEN ;              
                                                                
\ read an ip address from console until blank or valid                                                                
: getDestIp
  BEGIN 
    CR getDestIp inp_buff C@ 0= OR 
  UNTIL 
  CR
  inp_buff C@ 0> ;    

\ try to read an ip port number from console                                                                
: getDestPort ( -- fValidOrBlank )                                                     
  ." Enter Host Ip Port: "                                        
  inp_buff 1+ #5 ACCEPT DUP inp_buff C!                        
  IF inp_buff net-str>port ELSE FALSE THEN ;              
                                                                
\ read an ip port number from console until blank or valid                                                                
: getDestPort
  BEGIN 
    CR getDestPort 
    inp_buff C@ 0= OR 
  UNTIL 
  CR
  inp_buff C@ 0> ;    

\ return the W5X00 socket status  
: doStat
  sktidx skt-status ;

\ connect to the specified IP port and address
: doConnect ( uDestPort adrDestIpAdr -- fConnected )
  \ save destination port and address to 4 byte ip address buffer to return stack
  2>R
  \ get a new local port number for connection 
  sktidx 1 doNxtPort 2R> skt-open
  \ connect to socket if we can, press ESC key to terminate connection
  sktidx tcp-connect
  BEGIN
    \ see if we timed out or connected
    doStat DUP #23 = SWAP 0= OR
    \ if a key is pressed quit
    KEY? OR
    NOT
  WHILE
  \ not done so delay before we check again
    #10 MS
  REPEAT
  \ report connection socket status flag
  doStat #23 = ;

\ send data to terminal emulation
: ft-out ( cChar -- )
  DUP #32 < IF
    \ we have a control char
    CASE
      #13 OF #13 EMIT ENDOF
      #10 OF #10 EMIT ENDOF
      #11 OF CLR-EOL ENDOF
      #8  OF #8 EMIT ENDOF
      #2  OF nc-rx nc-rx SWAP AT-XY ENDOF
\      #14 OF vt-insln ENDOF
\      #15 OF vt-delln ENDOF
      #16 OF PAGE ENDOF
      #17 OF TRUE CURSOR ENDOF
      #18 OF FALSE CURSOR ENDOF
      #19 OF #19 nc-tx XY SWAP nc-tx nc-tx ENDOF
      #20 OF #20 nc-tx MAX-XY SWAP nc-tx nc-tx ENDOF
\      #21 OF 1 vt-color ENDOF
\      #22 OF 0 vt-color ENDOF     
    ENDCASE
  ELSE
    EMIT
  THEN ;

\ connect to a tcp server
\ use doSetIp to set server address, set VALUE destport to server port
: doTerm ( -- )
  PAGE
  \ tell net console not to reconnect 
  FALSE TO net_autocon
  \ close current console connection
  nc-close
  ." connecting..." CR CR 
  destport ip_adr doConnect IF
    ." connected. Press ESC to exit" CR
    EMPTY-KEYS  
    sktidx TO nc_socket
    TRUE TO net_constat
    nc-tcpbg
    BEGIN
     nc-tcpbg
     nc-rx? net_constat OR
    WHILE
      nc-rx? EMIT? AND IF nc-rx ft-out THEN
      KEY? nc-tx? AND IF
        \ if key = ExitChar exit terminal
        KEY DUP ExitChar = IF
          DROP
          nc-close
        ELSE
          TermEcho? IF DUP EMIT THEN nc-tx
        THEN   
      THEN
    REPEAT
    CR ." connection closed " CR
  ELSE   
    ." connection failed" CR
  THEN ;  

: doTerm ( fLocalEcho -- )
  TO TermEcho?
  getDestIp IF
    getDestPort IF
      TO destport
      doTerm
    THEN  
  THEN ;

: doListen ( -- )
  PAGE
  ." Listen for Terminal Connection " CR
  getDestPort IF
    TO svrport
    \ close current console connection
    nc-close
    \ tell net console to listen for new connection 
    TRUE TO net_autocon
    sktidx svrport nc-open IF
    ." Press ESC to quit, Waiting for connection..." CR
      BEGIN
        KEY? IF 
          KEY ExitChar = IF
            EXIT
          THEN  
        THEN  
        nc-tcpbg net_constat
      UNTIL
      ." connected." CR
      EMPTY-KEYS  
      BEGIN
       nc-tcpbg
       nc-rx? net_constat OR
      WHILE
        nc-rx? EMIT? AND IF 
          nc-rx ft-out 
        THEN
        KEY? nc-tx? AND IF
          \ if key = ExitChar exit terminal
          KEY DUP ExitChar = IF
            DROP
            nc-close
          ELSE   
            TermEcho? IF DUP EMIT THEN nc-tx
          THEN   
        THEN
      REPEAT
      CR ." connection closed " CR
    ELSE   
      ." listen failed " CR
    THEN
  THEN ;    

\ set local echo option then launch terminal
: doListen ( fLocalEcho -- )
  TO TermEcho?
  doListen ;
     