\ base64 string decode

: dec-digits ( -- cAdr uLen )
  S" ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=" ;
  
: dec-bits ( cEnc66Char -- u6BitValue )
  >R
  dec-digits
  ( cadr uLen  R: cEnc66Char)
  SWAP OVER R>
  ( uLen cadr ulen cEnc66Char )
  SCAN
  ( uLen cadr' uLen' )
  NIP 
  ( uLen uLen' )
  - #63 AND ;

\ a base64 block consists of 4 chars that map to 3 bytes
\ block chars are decoded in to base64 byte values   
: dec-blk ( cAdrIn cAdrOut -- )
  DUP #4 +
  ( cAdrIn cAdrOut cAdrOut' ) 
  SWAP 
  ( cAdrIn cAdrOut' cAdrOut ) 
  DO   
    ( cAdrIn )
    COUNT
    ( cAdrin' cChar )
    dec-bits
    ( cAdrin' cChar' )
    I C!
    ( cAdrin' )
  LOOP
  DROP ;   
  
\ pack 4 base64 char values in to 3 8 bit chars  
: dec-pack ( cAdrBytes -- dChars )
  >R 0. R>
  ( dPacked cAdrBytes )
  DUP #4 +
  ( dPacked cAdrBytes cAdrBytes' )
  SWAP DO
    ( dPacked )
    #6 DLSHIFT
    ( dPacked' )
    I C@ 0
    DOR
  LOOP ;

\ take chars packed in to a double an copy to string
\ return number of chars (0..3)  
: dec-dtostr ( dPackedChars aAdrStr -- )
  \ double MS word contains first char
  SWAP OVER
  ( uLPackedChars aAdrStr uHPackedChars aAdrStr )
  C! 1+
  ( uLPackedChars aAdrStr' )
  SWAP OVER OVER
  ( aAdrStr' uLPackedChars aAdrStr' uLPackedChars )
  #8 RSHIFT SWAP C!
  ( aAdrStr' uLPackedChars )
  #255 AND SWAP 1+ C! ;

\ decode a base64 encoded string
: base64dec ( c-adrDec c-adrSrc uBytes -- c-adrDec' uLenDec )
  \ save dest buffer address
  \ Base64 strings must be divisable by 4 ( 4 chars in == 3 bytes out)
  \ divide source length by 4 to get number of 3 byte blocks
  \ save copy of decode buffer address
  2>R DUP 2R>
  ( c-adrDec c-adrDec c-adrSrc uBytes ) 
  \ Calculate end of soure string + 1
  2DUP + SWAP
  ( c-adrDec c-adrDec c-adrSrc c-adrSrcEnd uBytes ) 
  \ divide source length by 4 to get number of 3 byte blocks
  DROP SWAP 
  ( c-adrDec c-adrDec c-adrSrcEnd  c-adrSrc )
  ?DO
    ( c-adrDec c-adrDec )
    DUP I SWAP
    ( c-adrDec c-adrDec c-adrSrc' c-adrDec )
    dec-blk 
    ( c-adrDec )
    DUP DUP dec-pack
    ( c-adrDec c-adrDec c-adrDec d3BytesPacked )
    ROT dec-dtostr
    ( c-adrDec c-adrDec )
    #3 +
  ( c-adrDec c-adrDec' )
  #4 +LOOP
  ( c-adrDec c-adrDec' )
  OVER - 
  ( c-adrDec uLen )
  2DUP 0 SCAN NIP -
  ( c-adrDec uLen' )
  ;
  
\ decodes to "shael is here"
\ : dec-samp ( -- cAdr Ulen )
\   S" c2hhZWwgaXMgaGVyZQ==" ;   

  