\ Requires "BasicAuthPasswords.forth".
\ Console utilities to add, update and delete users
\ in the basic authentication database


\ buffer to hold level number string
2VARIABLE pwn_num
  
\ read a two character number from the console
: ask-level ( -- FALSE | uLevel TRUE )
  0. pwn_num 2 ACCEPT pwn_num SWAP
  ( dNumber cadrStr uLenStr )
  \ IF string is blank fail
  ?DUP IF
    ( dNumber cadrStr uLenStr )
    >NUMBER NIP 0= IF
      D>S TRUE
    ELSE
      2DROP FALSE
    THEN 
  ELSE
    ( dNumber cadrStr )
    DROP 2DROP
    FALSE
  THEN ;  

\ add a new user or update a user password and level
: user-add ( -- ) 
  CR ." Add or update user:" CR
  ."  User Name: " 
  PAD 32 ACCEPT PAD SWAP
  ( cadrUser uUserLen )
  ?DUP IF
    ( cadrUser uUserLen )
    \ see if user is admin
    2DUP pwd-isadmin IF
      pwd_admin_level
    ELSE
      CR ."  User Level (1.." pwd_admin_level 1- 1 .R ." ): " 
      ask-level NOT IF
        0
      ELSE
        DUP 1 pwd_admin_level WITHIN NOT IF
          \ set level to 0 to indicate failed responce
          DROP 0
          #6 TO pwd_error
          ."  Error: " pwd-error.
        THEN  
      THEN
    THEN  
    ( cadrUser uUserLen uUserLevel )
    \ if user level = 0 we are done
    ?DUP IF
      ( cadrUser uUserLen uUserLevel )
      ROT ROT
      ( uUserLevel cadrUser uUserLen )
      CR ."  Password: "
      PAD #64 + #32 ACCEPT PAD #64 + SWAP
      ( uUserLevel cadrUser uUserLen cadrPwd uPwdLen )
      2SWAP 
      ( uUserLevel cadrPwd uPwdLen cadrUser uUserLen )
      CR
      \ see if the user already exists, save results to return stack
      2DUP pwd-fndusr IF
        DROP
        ." Update user " 
      ELSE 
        ." Add user '" 
      THEN
      2DUP TYPE 
      ( uUserLevel cadrPwd uPwdLen cadrUser uUserLen  R: uUserIndex )
      pwd-addusr IF 
        DROP
        ." ' was completed."
      ELSE 
        ."  failed, " pwd-error.
      THEN
    ELSE
      ( cadrUser uUserLen )
      2DROP
    THEN  
  ELSE
    ( cadrUser )
    DROP  
  THEN   
  CR ;

\ remove the user account by name  
: user-delete ( cadrUserName uLenUser -- )
  CR ." Delete user:" CR
  CR ."  User Name: " 
  PAD 32 ACCEPT PAD SWAP
  CR 
  pwd-delusr IF 
    ." Deleted from database" 
  ELSE 
    ." Delete failed, " pwd-error.
  THEN 
  CR ;

\ list all users that exists in the user database
: user-list ( -- )
  CR ." List all users:" CR
  pwd_blk BLOCK
  ( cadrDbEntry )
  pwd_max 1+ 0 DO
    DUP
    ( cadrDbEntry cadrDbEntry )
    \ skip blanks in case line is blank 
    #64 BL SKIP
    ( cadrDbEntry cadrDbEntry uLenDbEntry' )
    \ find end of name string  
    2DUP COLON SCAN NIP -
    ( cadrDbEntry cadrDbEntry uLenDbName )
    ?DUP IF
      SPACE TYPE SPACE I pwd-level . CR
    ELSE
      \ blank entry
      DROP
    THEN  
    #64 +
  LOOP
  DROP ;  
  