( Webserver Demo CGI functions )
\ This demo requires: 
\   I2C, S-3590a, W5100, net-console, 
\   webserver, and tools packages be loaded.
\ May also use Base64Decode and WebBasicAuth if basic authentication is used.

\ load basic authentication module
\ this code hooks the WEB-HDR defered word in the WebServer module.
\ For this demo the user database is save in block number 83
\ and can hold up to 15 user plus the admin account.
\ The value web_auth contains the current users authentication level (1..99)
\ if no user is logged in the value web_auth will be zero. The user_name variable
\ returns the address of a counted string containg the name of the logged on user.
#86 LOAD      \ load base64 decoder
#87 #88 THRU  \ load http basic authentication

\ To demo the user authentication we set some simple groups
#1 CONSTANT  UL_GUEST     \ guest account limited access
#99 CONSTANT UL_ADMIN     \ admin account full access
#10 CONSTANT UL_USER      \ min level for privliged access


\ Check authentication, return true if current user level at least uMinLevel.
\ If current user level less then uMinLevel return false and 
\ send an http authorization required error responce requesting 
\ Basic authentication.  
: chkauth ( uMinLevel -- )
  web_auth 1+ SWAP U> IF
    TRUE
  ELSE
    rsp-auth
    FALSE 
  THEN ;

\ static CGI functions, always in memory for speed

\ Show server date and time
: WEX-DATE
  0 rsp-text 
  ." Current Server Date:" CR .GMT ;

\ Show free memory and stack
: WEX-MEM
  0 rsp-text
  ." User: " 
  user_name COUNT ?DUP IF
    TYPE
  ELSE
    DROP
    ." (n/a)"
  THEN
  CR
  ." Blocks: " blk-count . CR
  ." Free Mem: " UNUSED . CR
  ." Stack: " .S ;

\ redefine .( to not print comments
\ Printed comments will cause the http server to fail
\ Dynamicaly loaded forth words must not output on the console while loading.
: .( [CHAR] ) WORD DROP ;

#60 #61 2CONSTANT t_range  \ set block range for tool functions
#80 #82 2CONSTANT c_range  \ set block range for CGI base responces 

\ dynamicaly loaded CGI function to access debug tools

: WEX-LIST ( -- )
  C" WEX-LIST" t_range exec-blocks ;

: WEX-DUMP ( -- )
  C" WEX-DUMP" t_range exec-blocks ;

: WEX-SEE ( -- )
  C" WEX-SEE" t_range exec-blocks ;

: WEX-WORDS ( -- )
  C" WEX-WORDS" t_range exec-blocks ;

: WEX-SETDATETIME ( -- )
  C" WEX-SETDATETIME" t_range exec-blocks ;
    
\ Html page responce CGI functions

\ dynamicaly loaded CGI function to send of create html pages

: WEX-demo ( -- )
  C" WEX-demo" c_range exec-blocks ;

: WEX-date ( -- )
  C" WEX-date" c_range exec-blocks ;

: WEX-favicon.ico ( -- )
  C" WEX-favicon.ico" c_range exec-blocks ;

: WEX-setpwd ( -- )
  C" WEX-setpwd" c_range exec-blocks ;

: WEX-updpwd ( -- )
  C" WEX-updpwd" c_range exec-blocks ;

