\ Constants
#17 CONSTANT net_maclen
#6  CONSTANT net_macdigits
#15 CONSTANT net_ip4len
#4  CONSTANT net_ip4digits

: net-mac>str ( a-adr c-adr - )
  BASE @ >R HEX DUP >R 
  1+ #6 0 DO 
    OVER C@ OVER SWAP 
    S>D <# # # #> >R SWAP R@ CMOVE
    R> + 
    I #5 <> IF 
      [CHAR] : OVER C!
    THEN 
    1+ SWAP 1+ SWAP
  LOOP NIP
  R@ - 2- R> C! R> BASE ! ;

: net-ip4>str ( a-adr c-adr - ) 
  BASE @ >R DECIMAL DUP >R 
  1+ #4 0 DO 
    OVER C@ OVER SWAP 
    S>D <# #S #> >R SWAP R@ CMOVE
    R> + 
    I #3 <> IF 
      [CHAR] . OVER C!
    THEN 
    1+ SWAP 1+ SWAP 
  LOOP NIP
  R@ - 2- R> C! R> BASE ! ;

: net-cntchar ( c-adr uLen cChar -- uCount )
  SWAP 0 SWAP 0 ?DO
    ( c-adr cChar uCount )
    ROT DUP C@ SWAP 1+ SWAP
    ( cChar uCount c-adr cTemp )
    2SWAP
    ( c-adr cTemp cChar uCount )
    ROT ROT DUP ROT
    ( c-adr uCount cChar cChar cTemp )
    = IF SWAP 1+ ELSE SWAP THEN
    ( c-adr uCount cChar )
  LOOP >R 2DROP R> ;

: net-split ( c-adr u c -- c-adr u1 c-adr2 u2 )
  >R 2DUP R> SCAN         
  DUP IF
    ( found correct results )
    2DUP 2>R
    NIP - 2R>
    1- SWAP 1+ SWAP
  THEN ;

: net-getdigit ( c-adr u c -- c-adr2 u2 u TRUE ) ( -- c-adr2 u2 FALSE )
  OVER 0> IF
    ( digit length may be valid )
    net-split 2SWAP 0. 2SWAP >NUMBER NIP 0= IF
      ( number converted, drop high word )
      DROP DUP 0 #256 WITHIN IF
        ( number is in range )
        TRUE
      ELSE
        ( number is out of range )
        DROP FALSE  
      THEN
    ELSE
      2DROP FALSE
    THEN
  ELSE
    DROP FALSE
  THEN ;

: net-ismac? ( c-adr u -- f ) DUP net_macdigits 2* 1- 
  net_maclen 1+ WITHIN IF
    ( string is correct length, correct number of digits )
    [CHAR] : net-cntchar net_macdigits 1- =
  ELSE
    ( string is to long or to short )
    2DROP FALSE
  THEN ;
: net-isip4? ( c-adr u -- f ) DUP net_ip4digits 2* 1- 
  net_ip4len 1+ WITHIN IF
    ( string is correct length, correct number of digits )
    [CHAR] . net-cntchar net_ip4digits 1- =
  ELSE
    ( string is to long or to short )
    2DROP FALSE
  THEN ;

: net-str>mac ( a-adr c-adr - f ) BASE @ >R HEX
  TRUE ROT ROT
  DUP COUNT net-ismac? IF
    COUNT net_macdigits 0 DO 
      [CHAR] : net-getdigit IF
        ( TRUE a-adr c-adr' u' n )
        2SWAP  
        ( TRUE u' n a-adr c-adr' )
        ROT ROT SWAP OVER
        ( TRUE u' c-adr' a-adr n a-adr )
        C! 1+
        ( TRUE u' c-adr' a-adr' )
        SWAP ROT
        ( TRUE a-adr' c-adr' u' )
      ELSE
        ( TRUE a-adr c-adr u )
        DROP FALSE SWAP 2SWAP
        ( FALSE c-adr TRUE c-adr )
        LEAVE
      THEN
    LOOP
    ( f a-adr c-adr u )
    DROP 2DROP
    ( f )
  ELSE
   ( mac string not proper form )
   ( TRUE a-adr c-adr )
    2DROP DROP FALSE
  THEN
  R> BASE !  ;

: net-str>ip4 ( a-adr c-adr - f ) BASE @ >R DECIMAL
  TRUE ROT ROT
  DUP COUNT net-isip4? IF
    COUNT net_ip4digits 0 DO 
      [CHAR] . net-getdigit IF
        ( TRUE a-adr c-adr' u' n )
        2SWAP  
        ( TRUE u' n a-adr c-adr' )
        ROT ROT SWAP OVER
        ( TRUE u' c-adr' a-adr n a-adr )
        C! 1+
        ( TRUE u' c-adr' a-adr' )
        SWAP ROT
        ( TRUE a-adr' c-adr' u' )
      ELSE
        ( TRUE a-adr c-adr u )
        DROP FALSE SWAP 2SWAP
        ( FALSE c-adr TRUE c-adr )
        LEAVE
      THEN
    LOOP
    ( f a-adr c-adr u )
    DROP 2DROP
    ( f )
  ELSE
   ( ip4 string not proper form )
   ( TRUE a-adr c-adr )
    2DROP DROP FALSE
  THEN
  R> BASE !  ;

: net-str>port ( c-adr -- uPort TRUE | FALSE )
  DUP C@ 0> IF
    ?DNUMBER IF
      D>S TRUE
    ELSE
      ( c-adr )
      DROP
      FALSE
    THEN
  ELSE
    ( c-adr )
    DROP
    FALSE
  THEN ;

: net-port>str ( uPort -- c-adr uLen )
  S>D <# #S #> ;  

\ : net_mac_str  C" 00:1D:61:E9:5B:88" ;
\ : net_ip_str   C" 10.0.1.12" ;
\ : net_mask_str C" 255.255.255.0" ;
\ : net_gw_str   C" 10.0.1.1" ;

\ net_mac net_mac_str net-str>mac DROP
\ net_ip net_ip_str net-str>ip4 DROP
\ net_mask net_mask_str net-str>ip4 DROP
\ net_gw net_gw_str net-str>ip4 DROP
