''Propeller Chip MV4th16 Using Direct I/O Demo
''
''All console and block I/O is handled by forth I/O COG.
''
''
''www.shaels.net
'
CON
  _clkmode = xtal1 + pll16x     'System clock PLL set to x 16
  '' Select correct crystal frequency
'  _xinfreq = 6_250_000         '6.250 Mhz (6.25 x 16 = 100.00 Mhz)
'  _xinfreq = 6_000_000         '6.000 Mhz (6.00 x 16 = 96.00 Mhz)
  _xinfreq = 5_000_000          '5.000 Mhz (5 x 16 = 80.00 Mhz)

'' NOTE:
''
'' Set Propeller chip I/O pin mapping in file MV4th16PinCfg.spin
''
  
  'Single long memory address used to comunicate with ForthBaseIo COG
  '
  c_SystemCommandAdr = $7FFC    'Used to pass a system command and stack pointer address
                                'from forth COG to another spin or asm object that performs I/O.
                                'The variables are two word sized values (16 bits each).
                                'We store the variables at the end of the forth stack.
                                
  'Higest memory address used by MV4th16 stack
  'system i/o buffers and variables are located from c_DataStackBaseAdr to c_SystemCommandAdr                               
  c_DataStackBaseAdr = IO#c_IODataStartAdr - 8  'leave 8 bytes as a pad between data stack base and I/O variables

  'number of COGS required for system IO
  c_IO_CogCount = IO#c_IO_CogCount
  
OBJ
  '' To use EEPROM as block device include IForthBaseIO.
  '' To use SD card as block device include IForthSdBaseIO.
  ''
  '' IForthBaseIO requires 2 COGS plus 1 COG for MV4th16.
  '' IForthSdBaseIO requires 3 COGS plus 1 COG for MV4th16.
  
  FORTH : "MV4th16"             ' Main forth system and virtual CPU code
'  IO    : "IForthBaseIO"       ' Uncomment this line for EEPROM block device
  IO    : "IForthSdBaseIO"      ' Uncomment this line for SD card block device


  '' IForthSdBaseIO includes the FAST FIND code so there is no need to load FAST FIND code.
  '' CODE TO ACTIVATE NEW FAST FIND:
  ''   ":NONAME LATEST @ #25 SYSTEM ; IS FIND" (without quotes)
  
  '' NOTE do not forget to set SD Card SPI pin numbers in file MV4th16PinCfg.spin


PUB Start
      ' Set Propeller chip I/O pin mapping in file MV4th16PinCfg.spin
      '
      ' Set baud rate and highest system address,
      ' used to send commands to forth system I/O cog
      IO.Start(115200, c_SystemCommandAdr)                                      ' start I/O sub-system
      '
      FORTH.Start(c_SystemCommandAdr, c_DataStackBaseAdr, c_IO_CogCount)        ' start forth 

        