'' Hardware pins configuration page for MV4th16
''
'' Added for version 0.94 to move all pin config constants to one place
CONST

'' I2C buss pins, default (SDA - 29, SCL - 28)

  c_Pin_I2C_SDA = 29
  c_Pin_I2C_SCL = 28

'' Async com port pins, default (TX - 30, RX - 31)

  c_Pin_COM_TX = 30
  c_Pin_COM_RX = 31
  '
'' SD card settings (used with SD card I/O):

  ' Parallax spinnet device
{              
  c_SPI_CS  = 19       ' SD card chip select line.
  c_SPI_CLK = 21       ' SD card SPI clock signal                               
  c_SPI_DI  = 20       ' SD card MOSI data line                        
  c_SPI_DO  = 16       ' SD card MISO data line
}
  
  ' Prop USB test board
'{              
  c_SPI_CS  = 24       ' SD card chip select line.
  c_SPI_CLK = 25       ' SD card SPI clock signal                               
  c_SPI_DI  = 26       ' SD card MOSI data line                        
  c_SPI_DO  = 27       ' SD card MISO data line
'}

'' Special option settings related to Propeller chip I/O pins

  'com port tx pin output mode, open drain or push/pull
  'use 25K..50K pullup resistor on tx pin for open drain mode
  c_ComTxOpenDrain = 4           ' open drain Tx pin
  c_ComTxPushPull = 0            ' push/pull Tx pin

  'Set c_ComTxMode = c_ModeOpenDrain when using an FTDI USB IC connected to pins 30 and 31 (Prop TX, RX).
  'Place a 25K...50K pullup resistor on pin 30 and pin 31 (Prop TX, Rx pins).
  'The Tx pullup in combination with the open drain driver will prevent the FTDI IC from reseting the 
  'prop chip when the prop chip transmits on pin 30 and the FTDI IC is not powered by a USB host.
  '
  'The pin 31 resistor will hold the Rx pin in the idle state when USB IC is not connect to a USB host.
  'In push/pull Tx drive mode a pullup may be required to hold the Rx pin in the idle state when not connected.

  ''Constant to pass desired com port Tx drive mode to I/O COG:
  '
' c_ComTxMode = c_ComTxOpenDrain ' use with FTDI USB connected to Propeller
                                 ' RX TX pins (requires 25K..50K pullup on pin 30),
                                 ' also requires a 25K..50K pullup on pin 31, Rx pin.
                                  
 c_ComTxMode = c_ComTxPushPull  ' normal CMOS level serial I/O, may require a
                                 ' 25K..50K pullup on pin 31, Rx pin.


PUB  Start
  